

-- FailBot w/ Support for : LDB-1.1, Sink-2.0, and configuration via AceOptions

local ADDON_NAME = "FailBoat"

local addon = LibStub("AceAddon-3.0"):NewAddon(ADDON_NAME, "LibSink-2.0")

local L	= LibStub("AceLocale-3.0"):GetLocale(ADDON_NAME)

local fail = LibStub("LibFail-1.0")

local defaults = {
	profile = {
		sinkoptions = { --[["sink20OutputSink"] = "Popup"]] },
	}
}

local options = {
    name = L["FailBoat"],
    desc = L["Shows humorous information about raid member failures."],
    type = "group",
    args = {
		output = addon:GetSinkAce3OptionsDataTable(),
    },
}



function addon:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("FailBoatDB", defaults, "Default")

	self:SetSinkStorage(self.db.profile.sinkoptions)

	local acreg = LibStub("AceConfigRegistry-3.0")
	
	acreg:RegisterOptionsTable(ADDON_NAME, options)
	
	local acdia = LibStub("AceConfigDialog-3.0")
	
	acdia:AddToBlizOptions(ADDON_NAME, ADDON_NAME)
	
	addon:RegisterChatCommand(ADDON_NAME:lower(), function() acdia:Open(ADDON_NAME) end)
end


local fail_events = {
	Fail_Sartheron_LavaWaves,
	Fail_Heigan_Dance,
	Fail_Any_VoidZone,
	Fail_Sapphiron_Breath,
	Fail_Frogger,
	Fail_Thaddius_PolaritySwitch,
	Fail_Thaddius_Jump,
}


function addon:OnEnable()
	for _, v in pairs(fail_events) do
		fail.RegisterEvent(self, v, "Fail")
	end
end


function addon:OnDisable()
	fail.UnregisterAllEvents(self)
end

function addon:Fail(event, ...)
	local txt = L[event]:format(...)

	self:Pour(txt)
end